unit uComboUTF8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, StdCtrls;

type
  TForm1 = class(TForm)
    cbComboUTF8: TComboBox;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure LoadComboUTF8();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var i: Integer;
    s: String;


procedure TForm1.LoadComboUTF8();
begin
  try
    with ADOQuery1 do
    begin
      {
      SQL.Clear;
      //SQL.Add('SET NAMES cp1251');
      SQL.Add('SET character_set_client = utf8');
      ExecSQL;

      SQL.Clear;
      SQL.Add('SET character_set_results = utf8');
      ExecSQL;

      SQL.Clear;
      SQL.Add('SET character_set_connection = utf8');
      ExecSQL;


      SQL.Clear;
      SQL.Add('SET NAMES cp1251');
      ExecSQL;
      }
      SQL.Clear;
      SQL.Add('SHOW VARIABLES LIKE ''character\_set\_%''');
      Active := True;
      AdoQuery1.First;
      while not AdoQuery1.Eof do
      begin
        Memo1.Lines.Insert(0, AdoQuery1.FieldByName('Variable_name').AsString + ' '
                              + AdoQuery1.FieldByName('value').AsString);
        AdoQuery1.Next;
      end;



      SQL.Clear;
      SQL.Add('SELECT * FROM category WHERE category = 1');
      Active := True;
      //ShowMessage(IntToStr(RecordCount));
    end;
  except
     on e:Exception do
  end;

  AdoQuery1.First;
  while not AdoQuery1.Eof do
  begin
    s := AdoQuery1.FieldByName('item').AsString;
    i := AdoQuery1.FieldByName('category').AsInteger;
    cbComboUTF8.AddItem(s, TObject(i));

    AdoQuery1.Next;
  end;

  ADOQuery1.Close;
  cbComboUTF8.ItemIndex := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadComboUTF8();
end;


end.
